org.apache.hc.core5.http.nio.support

## Class AbstractAsyncPushHandler<T>

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.AbstractAsyncPushHandler<T>

- Type Parameters:
    `T` - response message representation.
  All Implemented Interfaces:
    AsyncDataConsumer, AsyncPushConsumer, ResourceHolder

      public abstract class AbstractAsyncPushHandler<T>
      extends Object
      implements AsyncPushConsumer

  Abstract push response handler.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractAsyncPushHandler(AsyncResponseConsumer<T> responseConsumer)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `void` | `consumePromise(HttpRequest promise, HttpResponse response, EntityDetails entityDetails, HttpContext httpContext)` Triggered to signal receipt of a request message head used as a promise and the corresponding pushed response.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `protected void` | `handleError(HttpRequest promise, Exception cause)` Triggered to handle the exception thrown while processing a push response.
    `protected abstract void` | `handleResponse(HttpRequest promise, T responseMessage)` Triggered to handle the push message with the given promised request.
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractAsyncPushHandler

          public AbstractAsyncPushHandler(AsyncResponseConsumer<T> responseConsumer)

  - ### Method Detail

    - #### handleResponse

          protected abstract void handleResponse(HttpRequest promise,
                                                 T responseMessage)
                                          throws IOException,
                                                 HttpException

      Triggered to handle the push message with the given promised request.
      Parameters:
        `promise` - the promised request message.
        `responseMessage` - the pushed response message.
      Throws:
        `IOException` - in case of an I/O error.
        `HttpException` - in case of an HTTP protocol violation.

    - #### handleError

          protected void handleError(HttpRequest promise,
                                     Exception cause)

      Triggered to handle the exception thrown while processing a push response.
      Parameters:
        `promise` - the promised request message.
        `cause` - the cause of error.

    - #### consumePromise

          public final void consumePromise(HttpRequest promise,
                                           HttpResponse response,
                                           EntityDetails entityDetails,
                                           HttpContext httpContext)
                                    throws HttpException,
                                           IOException

      Description copied from interface: `AsyncPushConsumer`
      Triggered to signal receipt of a request message head used as a promise and the corresponding pushed response.
      Specified by:
        `consumePromise` in interface `AsyncPushConsumer`
      Parameters:
        `promise` - the request message head used as a promise.
        `response` - the pushed response message.
        `entityDetails` - the response entity details or `null` if the response does not enclose an entity.
        `httpContext` - the actual execution context.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### updateCapacity

          public final void updateCapacity(CapacityChannel capacityChannel)
                                    throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException` - in case of an I/O error.

    - #### consume

          public final void consume(ByteBuffer src)
                             throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException` - in case of an I/O error.

    - #### streamEnd

          public final void streamEnd(List<? extends Header> trailers)
                               throws HttpException,
                                      IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### failed

          public final void failed(Exception cause)

      Description copied from interface: `AsyncPushConsumer`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncPushConsumer`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public final void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.